Subject: Re: bug#21514: Guile 2.2: Sluggish elf calls, esp around arity / promises / statprof

From: Andy Wingo <[email-masked]>
Date: Fri, 24 Jun 2016 14:24:37 +0200

On Fri 18 Sep 2015 17:19, Christopher Allan Webber <[email-masked]> writes:

> I was testing a program of mine under Guile 2.2, and was surprised to
> find things slower than in Guile 2.0, surprising given all the various
> optimizations I've heard about!  However, I think I've found good clues
> as to what's going on.

(Summary: procedure-minimum-arity, called via `thunk?' when making
promises, was doing a lot of work, grovelling debuginfo to answer simple
questions.)

I fixed procedure-minimum-arity to be quicker, which should fix this
bug.  Please let me know if you see thunk? as a perf problem in your use
case.

In the meantime I seem to have broken ,trace :/  I'll see what the deal
is there.

Andy